Imports System.Math
Imports System.Environment
Imports System.IO
Imports System.Drawing.Imaging

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picDesktop As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picDesktop = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'picDesktop
        '
        Me.picDesktop.Cursor = System.Windows.Forms.Cursors.Cross
        Me.picDesktop.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picDesktop.Location = New System.Drawing.Point(0, 0)
        Me.picDesktop.Name = "picDesktop"
        Me.picDesktop.Size = New System.Drawing.Size(288, 256)
        Me.picDesktop.TabIndex = 0
        Me.picDesktop.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(288, 256)
        Me.ControlBox = False
        Me.Controls.Add(Me.picDesktop)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.Name = "Form1"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Rubberband rectangle coordinates.
    Private m_Drawing As Boolean = False
    Private m_X1 As Integer
    Private m_Y1 As Integer
    Private m_X2 As Integer
    Private m_Y2 As Integer

    ' A saved image of the desktop.
    Private m_bmDesktop As Bitmap

    ' Drawing variables.
    Private m_grDesktop As Graphics

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Hide()
        Application.DoEvents()

        ' Get the desktop image.
        m_bmDesktop = DesktopImage()

        ' Display the image.
        picDesktop.Image = DirectCast(m_bmDesktop.Clone(), Bitmap)
        Me.Show()
    End Sub

    ' Start dragging to select an area.
    Private Sub picDesktop_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picDesktop.MouseDown
        m_Drawing = True

        ' Save the point's coordinates.
        m_X1 = e.X
        m_X2 = e.X
        m_Y1 = e.Y
        m_Y2 = e.Y

        ' Make a Graphics object to draw on.
        m_grDesktop = picDesktop.CreateGraphics()
    End Sub

    ' Continue drawing.
    Private Sub picDesktop_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picDesktop.MouseMove
        If Not m_Drawing Then Exit Sub

        ' Save the new point.
        m_X2 = e.X
        m_Y2 = e.Y

        ' Redraw the desktop image.
        m_grDesktop.DrawImage(m_bmDesktop, 0, 0)

        ' Draw the rubberband rectangle.
        Dim rect As New Rectangle( _
            Min(m_X1, m_X2), Min(m_Y1, m_Y2), _
            Abs(m_X1 - m_X2), Abs(m_Y1 - m_Y2))
        m_grDesktop.DrawRectangle(Pens.Blue, rect)
    End Sub

    ' Stop drawing.
    Private Sub picDesktop_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picDesktop.MouseUp
        If Not m_Drawing Then Exit Sub
        m_Drawing = False

        ' Hide the form.
        Me.Hide()

        ' Get the name of a file on the desktop.
        Dim file_path As String = GetFolderPath(SpecialFolder.Desktop)
        If Not file_path.EndsWith("\") Then file_path &= "\"
        file_path &= "Screen Grab"

        Dim file_name As String
        For i As Integer = 0 To 1000000
            file_name = file_path & i.ToString & ".jpg"
            Dim file_info As New FileInfo(file_name)
            If Not file_info.Exists() Then Exit For
        Next i

        ' Grab the selected piece of the image.
        Dim rect As New Rectangle( _
            Min(m_X1, m_X2), Min(m_Y1, m_Y2), _
            Abs(m_X1 - m_X2), Abs(m_Y1 - m_Y2))
        Dim bm As Bitmap = DirectCast( _
            m_bmDesktop.Clone(rect, m_bmDesktop.PixelFormat), Bitmap)

        ' Save the image into the file.
        bm.Save(file_name, ImageFormat.Jpeg)

        ' Unload.
        Me.Close()
    End Sub

#Region "Desktop Capture Routines"
    Private Declare Function GetDesktopWindow Lib "user32" () As Int32
    Private Declare Function GetDC Lib "user32" (ByVal hwnd As Int32) As Int32
    Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As IntPtr, ByVal x As Int32, ByVal y As Int32, ByVal nWidth As Int32, ByVal nHeight As Int32, ByVal hSrcDC As Int32, ByVal xSrc As Int32, ByVal ySrc As Int32, ByVal nSrcWidth As Int32, ByVal nSrcHeight As Int32, ByVal dwRop As Int32) As Int32
    Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Int32, ByVal hdc As Int32) As Int32
    Private Structure RECT
        Dim Left As Int32
        Dim Top As Int32
        Dim Right As Int32
        Dim Bottom As Int32
    End Structure
    Private Const SRCCOPY As Int32 = &HCC0020

    ' Return an image of the desktop.
    Private Function DesktopImage() As Bitmap
        ' Get the desktop size in pixels.
        Dim desktop_win As Int32 = GetDesktopWindow()
        Dim desktop_dc As Int32 = GetDC(desktop_win)
        Dim desktop_bounds As Rectangle = Screen.GetBounds(New Point(1, 1))
        Dim desktop_wid As Int32 = desktop_bounds.Width
        Dim desktop_hgt As Int32 = desktop_bounds.Height

        ' Make a Bitmap to hold the image.
        Dim bm As New Bitmap(desktop_wid, desktop_hgt)
        Dim bm_gr As Graphics = Graphics.FromImage(bm)
        Dim bm_hdc As IntPtr = bm_gr.GetHdc

        ' Copy the desktop's image.
        StretchBlt( _
            bm_hdc, 0, 0, desktop_wid, desktop_hgt, _
            desktop_dc, 0, 0, desktop_wid, desktop_hgt, _
            SRCCOPY)

        ' Release the bitmap's  and desktop's DCs.
        bm_gr.ReleaseHdc(bm_hdc)
        ReleaseDC(desktop_win, desktop_dc)

        ' Return the result.
        Return bm
    End Function
#End Region ' Desktop Capture Routines
End Class

